import java.rmi.*;
import java.rmi.server.*;
import java.util.Vector;

public class ChatManagerImpl extends UnicastRemoteObject implements ChatManager
{
   private Vector listener;

   public ChatManagerImpl() throws RemoteException
   {
      super();
      listener = new Vector( 100 );
   }

   // This implementation is a simple echo server.
   // Other implementations could remember the conversation
   public void postMessage( String message ) throws RemoteException
   {
      Vector l;
      l = (Vector)listener.clone();

      for ( int i = 0; i < l.size() ; i++ )
      {
         ChatListener cl = (ChatListener)l.elementAt( i );
         try
         {
            cl.postMessage( message );
         }
         catch ( Exception e )
         {
            listener.removeElement( cl );
         }
      }

   }

   public void registerListener( ChatListener cl ) throws RemoteException
   {
      listener.addElement( cl );
   }

   public void unregisterListener( ChatListener cl ) throws RemoteException
   {
      listener.removeElement( cl );
   }

}
